#!/usr/bin/env python
# -*- coding: utf-8 -*-

# This file is part of Beremiz, a Integrated Development Environment for
# programming IEC 61131-3 automates supporting plcopen standard and CanFestival.
#
# Copyright (C) 2007: Edouard TISSERANT and Laurent BESSARD
#
# See COPYING file for copyrights details.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.


# Package initialization

from __future__ import absolute_import

from dialogs.CommentEditDialog import CommentEditDialog
from dialogs.ConnectionDialog import ConnectionDialog
from dialogs.ActionBlockDialog import ActionBlockDialog
from dialogs.FBDBlockDialog import FBDBlockDialog
from dialogs.FBDVariableDialog import FBDVariableDialog
from dialogs.LDElementDialog import LDElementDialog
from dialogs.LDPowerRailDialog import LDPowerRailDialog
from dialogs.SFCStepDialog import SFCStepDialog
from dialogs.SFCStepNameDialog import SFCStepNameDialog
from dialogs.SFCTransitionDialog import SFCTransitionDialog
from dialogs.SFCDivergenceDialog import SFCDivergenceDialog
from dialogs.ForceVariableDialog import ForceVariableDialog
from dialogs.ArrayTypeDialog import ArrayTypeDialog
from dialogs.DurationEditorDialog import DurationEditorDialog
from dialogs.SearchInProjectDialog import SearchInProjectDialog
from dialogs.BrowseLocationsDialog import BrowseLocationsDialog
from dialogs.ProjectDialog import ProjectDialog
from dialogs.PouDialog import PouDialog
from dialogs.PouTransitionDialog import PouTransitionDialog
from dialogs.PouActionDialog import PouActionDialog
from dialogs.FindInPouDialog import FindInPouDialog
from dialogs.BrowseValuesLibraryDialog import BrowseValuesLibraryDialog
from dialogs.UriEditor import UriEditor
from dialogs.IDManager import IDManager
